﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace _111860
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet ds = new DataSet();
            DataTable root = new DataTable("A");
            root.Columns.Add("id", typeof(int)).AutoIncrement = true;
            root.Columns.Add("column", typeof(string)).Expression = "'A' + id";

            DataTable child1 = new DataTable("B");
            child1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            child1.Columns.Add("pid", typeof(int));
            child1.Columns.Add("column", typeof(string)).Expression = "'B' + id";
           
            DataTable child2 = new DataTable("C");
            child2.Columns.Add("id", typeof(int)).AutoIncrement = true;
            child2.Columns.Add("pid", typeof(int));
            child2.Columns.Add("column", typeof(string)).Expression = "'C'+ id";
            child2.Columns.Add("sp1", typeof(string)).Expression = "'SP1' +id";
            child2.Columns.Add("sp2", typeof(string)).Expression = "'SP2'+id";

            ds.Tables.AddRange(new DataTable[] { root, child1, child2 });
            ds.Relations.Add(root.Columns["id"], child1.Columns["pid"]);
            ds.Relations.Add(child1.Columns["id"], child2.Columns["pid"]);


            for (int i = 0; i < 3; i++)
            {
                DataRow rootRow = root.Rows.Add();
                for (int j = 0; j < 3; j++)
                {
                    DataRow child1Row = child1.Rows.Add(null, rootRow["id"]);
                    for (int k = 0; k < 2; k++)
                    {
                        child2.Rows.Add(null, child1Row["id"]);
                    }
                }
            }


            ultraGrid1.DataSource = ds;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            foreach (UltraGridBand b in e.Layout.Bands)
                b.ColHeadersVisible = false;
            e.Layout.Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.None;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.Band.Index == 2)
            {
                if (e.Row.Band.Columns.Exists("sp1"))
                    e.Row.Cells["sp1"].Hidden = true;
                if (e.Row.Band.Columns.Exists("sp2"))
                    e.Row.Cells["sp2"].Hidden = true;
            }
        }

        private void ultraGrid1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
           RowUIElement row =  e.Element.GetAncestor(typeof(RowUIElement)) as RowUIElement;
            if(meetsCriteria(row))
            {
                row.Row.Cells["sp1"].Hidden = false;
                row.Row.Cells["sp2"].Hidden = false;
            }
               
        }

        private bool meetsCriteria(RowUIElement row)
        {
            if (row == null)
                return false;
            if (row.Row.Band.Columns.Exists("sp1") && row.Row.Band.Columns.Exists("sp2"))
                return row.Row.Index == 0;
            else
                return false;
        }

        private void ultraGrid1_MouseLeaveElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            RowUIElement row = e.Element.GetAncestor(typeof(RowUIElement)) as RowUIElement;
            if (meetsCriteria(row))
            {
                row.Row.Cells["sp1"].Hidden = true;
                row.Row.Cells["sp2"].Hidden = true;
            }
        }


    }
}
